Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1797)
@@ -1901,321 +1981,337 @@
 
 
-!-- TO_DO:  indentation and wrap long lines from here on to the end of the file
-   SUBROUTINE pmci_init_anterp_tophat
-!
-!--   Precomputation of the client-array indices for 
-!--   corresponding coarse-grid array index and the 
-!--   Under-relaxation coefficients to be used by anterp_tophat.
-
-      IMPLICIT NONE
-
-      INTEGER(iwp) ::  i        !: Fine-grid index
-      INTEGER(iwp) ::  ii       !: Coarse-grid index
-      INTEGER(iwp) ::  istart   !:
-      INTEGER(iwp) ::  j        !: Fine-grid index
-      INTEGER(iwp) ::  jj       !: Coarse-grid index
-      INTEGER(iwp) ::  jstart   !:
-      INTEGER(iwp) ::  k        !: Fine-grid index
-      INTEGER(iwp) ::  kk       !: Coarse-grid index
-      INTEGER(iwp) ::  kstart   !:
-      REAL(wp)     ::  xi       !:
-      REAL(wp)     ::  eta      !:
-      REAL(wp)     ::  zeta     !:
+
+
+    SUBROUTINE pmci_init_anterp_tophat
+!
+!--    Precomputation of the client-array indices for
+!--    corresponding coarse-grid array index and the
+!--    Under-relaxation coefficients to be used by anterp_tophat.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i        !: Fine-grid index
+       INTEGER(iwp) ::  ii       !: Coarse-grid index
+       INTEGER(iwp) ::  istart   !:
+       INTEGER(iwp) ::  j        !: Fine-grid index
+       INTEGER(iwp) ::  jj       !: Coarse-grid index
+       INTEGER(iwp) ::  jstart   !:
+       INTEGER(iwp) ::  k        !: Fine-grid index
+       INTEGER(iwp) ::  kk       !: Coarse-grid index
+       INTEGER(iwp) ::  kstart   !:
+       REAL(wp)     ::  xi       !:
+       REAL(wp)     ::  eta      !:
+       REAL(wp)     ::  zeta     !:
      
-
-!
-!--   Default values:
-      IF ( anterp_relax_length_l < 0.0_wp )  THEN
-         anterp_relax_length_l = 0.1_wp * ( nx + 1 ) * dx
-      ENDIF
-      IF ( anterp_relax_length_r < 0.0_wp )  THEN
-         anterp_relax_length_r = 0.1_wp * ( nx + 1 ) * dx
-      ENDIF
-      IF ( anterp_relax_length_s < 0.0_wp )  THEN
-         anterp_relax_length_s = 0.1_wp * ( ny + 1 ) * dy
-      ENDIF
-      IF ( anterp_relax_length_n < 0.0_wp )  THEN
-         anterp_relax_length_n = 0.1_wp * ( ny + 1 ) * dy
-      ENDIF
-      IF ( anterp_relax_length_t < 0.0_wp )  THEN
-         anterp_relax_length_t = 0.1_wp * zu(nzt)
-      ENDIF
-
-!
-!--   First determine kctu and kctw that are the coarse-grid upper bounds for index k.
-      kk = 0
-      DO  WHILE ( cg%zu(kk) < zu(nzt) )
-         kk = kk + 1
-      ENDDO
-      kctu = kk - 1 
-
-      kk = 0
-      DO  WHILE ( cg%zw(kk) < zw(nzt-1) )
-         kk = kk + 1
-      ENDDO
-      kctw = kk - 1 
-
-      ALLOCATE( iflu(icl:icr) )
-      ALLOCATE( iflo(icl:icr) )
-      ALLOCATE( ifuu(icl:icr) )
-      ALLOCATE( ifuo(icl:icr) )
-      ALLOCATE( jflv(jcs:jcn) )
-      ALLOCATE( jflo(jcs:jcn) )
-      ALLOCATE( jfuv(jcs:jcn) )
-      ALLOCATE( jfuo(jcs:jcn) )
-      ALLOCATE( kflw(0:kctw) )
-      ALLOCATE( kflo(0:kctu) )
-      ALLOCATE( kfuw(0:kctw) )
-      ALLOCATE( kfuo(0:kctu) )
-
-!
-!--   i-indices of u for each l-index value.    
-      istart = nxlg
-      DO  ii = icl, icr  
-         i = istart
-         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
-            i = i + 1
-         ENDDO
-         iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
-         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
-            i = i + 1
-         ENDDO
-         ifuu(ii) = MIN( MAX( i, nxlg ), nxrg )
-         istart = iflu(ii)
-      ENDDO
-
-!
-!--   i-indices of others for each l-index value.
-      istart = nxlg
-      DO  ii = icl, icr   
-         i = istart
-         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(ii) )  .AND.  ( i < nxrg ) ) 
-            i = i + 1
-         ENDDO
-         iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
-         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(ii) + cg%dx )  .AND.  ( i < nxrg ) ) 
-            i = i + 1
-         ENDDO
-         ifuo(ii) = MIN(MAX(i,nxlg),nxrg)
-         istart = iflo(ii)
-      ENDDO
-
-!
-!--   j-indices of v for each m-index value.
-      jstart = nysg
-      DO  jj = jcs, jcn
-         j = jstart
-         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
-            j = j + 1
-         ENDDO
-         jflv(jj) = MIN( MAX( j, nysg ), nyng ) 
-         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
-            j = j + 1
-         ENDDO
-         jfuv(jj) = MIN( MAX( j, nysg ), nyng )
-         jstart = jflv(jj)
-      ENDDO
-
-!
-!--   j-indices of others for each m-index value.
-      jstart = nysg
-      DO  jj = jcs, jcn
-         j = jstart
-         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(jj) )  .AND.  ( j < nyng ) )  
-            j = j + 1
-         ENDDO
-         jflo(jj) = MIN( MAX( j, nysg ), nyng )
-         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(jj) + cg%dy )  .AND.  ( j < nyng ) ) 
-            j = j + 1
-         ENDDO
-         jfuo(jj) = MIN( MAX( j, nysg ), nyng )
-         jstart = jflv(jj)
-      ENDDO
-
-!
-!--   k-indices of w for each n-index value.
-      kstart  = 0
-      kflw(0) = 0
-      kfuw(0) = 0
-      DO  kk = 1, kctw
-         k = kstart
-         DO  WHILE ( ( zw(k) < cg%zw(kk) - 0.5_wp * cg%dzw(kk) )  .AND.  ( k < nzt ) ) 
-            k = k + 1
-         ENDDO
-         kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-         DO  WHILE ( ( zw(k) < cg%zw(kk) + 0.5_wp * cg%dzw(kk+1) )  .AND.  ( k < nzt ) ) 
-            k = k + 1
-         ENDDO
-         kfuw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-         kstart = kflw(kk)
-      ENDDO
-
-!
-!--   k-indices of others for each n-index value.
-      kstart  = 0
-      kflo(0) = 0
-      kfuo(0) = 0
-      DO  kk = 1, kctu
-         k = kstart
-         DO  WHILE ( ( zu(k) < cg%zu(kk) - 0.5_wp * cg%dzu(kk) )  .AND.  ( k < nzt ) ) 
-            k = k + 1
-         ENDDO
-         kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-         DO  WHILE ( ( zu(k) < cg%zu(kk) + 0.5_wp * cg%dzu(kk+1) )  .AND.  ( k < nzt ) )  
-            k = k + 1
-         ENDDO
-         kfuo(kk) = MIN( MAX( k-1, 1 ), nzt + 1 )
-         kstart = kflo(kk)
-      ENDDO
+!
+!--    Default values:
+       IF ( anterp_relax_length_l < 0.0_wp )  THEN
+          anterp_relax_length_l = 0.1_wp * ( nx + 1 ) * dx
+       ENDIF
+       IF ( anterp_relax_length_r < 0.0_wp )  THEN
+          anterp_relax_length_r = 0.1_wp * ( nx + 1 ) * dx
+       ENDIF
+       IF ( anterp_relax_length_s < 0.0_wp )  THEN
+          anterp_relax_length_s = 0.1_wp * ( ny + 1 ) * dy
+       ENDIF
+       IF ( anterp_relax_length_n < 0.0_wp )  THEN
+          anterp_relax_length_n = 0.1_wp * ( ny + 1 ) * dy
+       ENDIF
+       IF ( anterp_relax_length_t < 0.0_wp )  THEN
+          anterp_relax_length_t = 0.1_wp * zu(nzt)
+       ENDIF
+
+!
+!--    First determine kctu and kctw that are the coarse-grid upper bounds for
+!--    index k
+       kk = 0
+       DO  WHILE ( cg%zu(kk) < zu(nzt) )
+          kk = kk + 1
+       ENDDO
+       kctu = kk - 1
+
+       kk = 0
+       DO  WHILE ( cg%zw(kk) < zw(nzt-1) )
+          kk = kk + 1
+       ENDDO
+       kctw = kk - 1
+
+       ALLOCATE( iflu(icl:icr) )
+       ALLOCATE( iflo(icl:icr) )
+       ALLOCATE( ifuu(icl:icr) )
+       ALLOCATE( ifuo(icl:icr) )
+       ALLOCATE( jflv(jcs:jcn) )
+       ALLOCATE( jflo(jcs:jcn) )
+       ALLOCATE( jfuv(jcs:jcn) )
+       ALLOCATE( jfuo(jcs:jcn) )
+       ALLOCATE( kflw(0:kctw) )
+       ALLOCATE( kflo(0:kctu) )
+       ALLOCATE( kfuw(0:kctw) )
+       ALLOCATE( kfuo(0:kctu) )
+
+!
+!--    i-indices of u for each ii-index value
+       istart = nxlg
+       DO  ii = icl, icr
+          i = istart
+          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  &
+                      ( i < nxrg ) )
+             i = i + 1
+          ENDDO
+          iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
+          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.  &
+                      ( i < nxrg ) )
+             i = i + 1
+          ENDDO
+          ifuu(ii) = MIN( MAX( i, nxlg ), nxrg )
+          istart = iflu(ii)
+       ENDDO
+
+!
+!--    i-indices of others for each ii-index value
+       istart = nxlg
+       DO  ii = icl, icr
+          i = istart
+          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.     &
+                      ( i < nxrg ) )
+             i = i + 1
+          ENDDO
+          iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
+          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) + cg%dx )    &
+                      .AND.  ( i < nxrg ) )
+             i = i + 1
+          ENDDO
+          ifuo(ii) = MIN(MAX(i,nxlg),nxrg)
+          istart = iflo(ii)
+       ENDDO
+
+!
+!--    j-indices of v for each jj-index value
+       jstart = nysg
+       DO  jj = jcs, jcn
+          j = jstart
+          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  &
+                      ( j < nyng ) )
+             j = j + 1
+          ENDDO
+          jflv(jj) = MIN( MAX( j, nysg ), nyng )
+          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.  &
+                      ( j < nyng ) )
+             j = j + 1
+          ENDDO
+          jfuv(jj) = MIN( MAX( j, nysg ), nyng )
+          jstart = jflv(jj)
+       ENDDO
+
+!
+!--    j-indices of others for each jj-index value
+       jstart = nysg
+       DO  jj = jcs, jcn
+          j = jstart
+          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.     &
+                      ( j < nyng ) )
+             j = j + 1
+          ENDDO
+          jflo(jj) = MIN( MAX( j, nysg ), nyng )
+          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) + cg%dy )    &
+                      .AND.  ( j < nyng ) )
+             j = j + 1
+          ENDDO
+          jfuo(jj) = MIN( MAX( j, nysg ), nyng )
+          jstart = jflv(jj)
+       ENDDO
+
+!
+!--    k-indices of w for each kk-index value
+       kstart  = 0
+       kflw(0) = 0
+       kfuw(0) = 0
+       DO  kk = 1, kctw
+          k = kstart
+          DO  WHILE ( ( zw(k) < cg%zw(kk) - 0.5_wp * cg%dzw(kk) )  .AND.       &
+                      ( k < nzt ) )
+             k = k + 1
+          ENDDO
+          kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+          DO  WHILE ( ( zw(k) < cg%zw(kk) + 0.5_wp * cg%dzw(kk+1) )  .AND.     &
+                      ( k < nzt ) )
+             k = k + 1
+          ENDDO
+          kfuw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+          kstart = kflw(kk)
+       ENDDO
+
+!
+!--    k-indices of others for each kk-index value
+       kstart  = 0
+       kflo(0) = 0
+       kfuo(0) = 0
+       DO  kk = 1, kctu
+          k = kstart
+          DO  WHILE ( ( zu(k) < cg%zu(kk) - 0.5_wp * cg%dzu(kk) )  .AND.       &
+                      ( k < nzt ) )
+             k = k + 1
+          ENDDO
+          kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+          DO  WHILE ( ( zu(k) < cg%zu(kk) + 0.5_wp * cg%dzu(kk+1) )  .AND.     &
+                      ( k < nzt ) )
+             k = k + 1
+          ENDDO
+          kfuo(kk) = MIN( MAX( k-1, 1 ), nzt + 1 )
+          kstart = kflo(kk)
+       ENDDO
      
 !
-!--   Spatial under-relaxation coefficients
-      ALLOCATE( frax(icl:icr) )
-
-      DO  ii = icl, icr
-         IF ( nest_bound_l ) THEN
-            xi   = ( MAX( 0.0_wp, ( cg%coord_x(ii) - lower_left_coord_x ) ) / anterp_relax_length_l )**4
-         ELSEIF ( nest_bound_r ) THEN
-            xi   = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx - cg%coord_x(ii) ) ) / anterp_relax_length_r )**4
-         ELSE
-            xi   = 999999.9_wp
-         ENDIF
-         frax(ii)  = xi / ( 1.0_wp + xi )
-      ENDDO
-
-      ALLOCATE( fray(jcs:jcn) )
-
-      DO  jj = jcs, jcn
-         IF ( nest_bound_s ) THEN           
-            eta  = ( MAX( 0.0_wp, ( cg%coord_y(jj) - lower_left_coord_y ) ) / anterp_relax_length_s )**4
-         ELSEIF ( nest_bound_n ) THEN
-            eta  = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy - cg%coord_y(jj)) ) / anterp_relax_length_n )**4
-         ELSE
-            eta  = 999999.9_wp
-         ENDIF
-         fray(jj)  = eta / ( 1.0_wp + eta )
-      ENDDO
+!--    Spatial under-relaxation coefficients
+       ALLOCATE( frax(icl:icr) )
+
+       DO  ii = icl, icr
+          IF ( nest_bound_l )  THEN
+             xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) - lower_left_coord_x ) ) /   &
+                    anterp_relax_length_l )**4
+          ELSEIF ( nest_bound_r )  THEN
+             xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -      &
+                                   cg%coord_x(ii) ) ) /                        &
+                    anterp_relax_length_r )**4
+          ELSE
+             xi = 999999.9_wp
+          ENDIF
+          frax(ii) = xi / ( 1.0_wp + xi )
+       ENDDO
+
+       ALLOCATE( fray(jcs:jcn) )
+
+       DO  jj = jcs, jcn
+          IF ( nest_bound_s )  THEN
+             eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) - lower_left_coord_y ) ) /  &
+                     anterp_relax_length_s )**4
+          ELSEIF ( nest_bound_n )  THEN
+             eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -     &
+                                    cg%coord_y(jj)) ) /                        &
+                     anterp_relax_length_n )**4
+          ELSE
+             eta = 999999.9_wp
+          ENDIF
+          fray(jj) = eta / ( 1.0_wp + eta )
+       ENDDO
       
-      ALLOCATE( fraz(0:kctu) )
-      DO  kk = 0, kctu        
-         zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4       
-         fraz(kk) = zeta / ( 1.0_wp + zeta )
-      ENDDO
-
-   END SUBROUTINE pmci_init_anterp_tophat
-
-
-
-   SUBROUTINE pmci_init_tkefactor
-
-!
-!--   Computes the scaling factor for the SGS TKE from coarse grid to be used 
-!--   as BC for the fine grid. Based on the Kolmogorov energy spectrum
-!--   for the inertial subrange and assumption of sharp cut-off of the resolved 
-!--   energy spectrum. Near the surface, the reduction of TKE is made 
-!--   smaller than further away from the surface.
-!
-!                      Antti Hellsten 4.3.2015
-!
-!--   Extended for non-flat topography and variable dz.
-! 
-!                      Antti Hellsten 26.3.2015
-!
-!--   The current near-wall adaptation can be replaced by a new one which
-!--   uses a step function [0,1] based on the logc-arrays. AH 30.12.2015
-      IMPLICIT NONE
-      REAL(wp), PARAMETER  ::  cfw = 0.2_wp          !:
-      REAL(wp), PARAMETER  ::  c_tkef = 0.6_wp       !:
-      REAL(wp)             ::  fw                    !:
-      REAL(wp), PARAMETER  ::  fw0 = 0.9_wp          !:
-      REAL(wp)             ::  glsf                  !:
-      REAL(wp)             ::  glsc                  !:
-      REAL(wp)             ::  height                !:
-      REAL(wp), PARAMETER  ::  p13 = 1.0_wp/3.0_wp   !:
-      REAL(wp), PARAMETER  ::  p23 = 2.0_wp/3.0_wp   !:
-      INTEGER(iwp)         ::  k                     !:
-      INTEGER(iwp)         ::  kc                    !:
+       ALLOCATE( fraz(0:kctu) )
+       DO  kk = 0, kctu
+          zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4
+          fraz(kk) = zeta / ( 1.0_wp + zeta )
+       ENDDO
+
+    END SUBROUTINE pmci_init_anterp_tophat
+
+
+
+    SUBROUTINE pmci_init_tkefactor
+
+!
+!--    Computes the scaling factor for the SGS TKE from coarse grid to be used
+!--    as BC for the fine grid. Based on the Kolmogorov energy spectrum
+!--    for the inertial subrange and assumption of sharp cut-off of the resolved
+!--    energy spectrum. Near the surface, the reduction of TKE is made
+!--    smaller than further away from the surface.
+
+       IMPLICIT NONE
+       REAL(wp), PARAMETER ::  cfw = 0.2_wp          !:
+       REAL(wp), PARAMETER ::  c_tkef = 0.6_wp       !:
+       REAL(wp)            ::  fw                    !:
+       REAL(wp), PARAMETER ::  fw0 = 0.9_wp          !:
+       REAL(wp)            ::  glsf                  !:
+       REAL(wp)            ::  glsc                  !:
+       REAL(wp)            ::  height                !:
+       REAL(wp), PARAMETER ::  p13 = 1.0_wp/3.0_wp   !:
+       REAL(wp), PARAMETER ::  p23 = 2.0_wp/3.0_wp   !:
+       INTEGER(iwp)        ::  k                     !:
+       INTEGER(iwp)        ::  kc                    !:
         
 
-      IF ( nest_bound_l )  THEN
-         ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )    
-         tkefactor_l = 0.0_wp
-         i = nxl - 1 
-         DO  j = nysg, nyng
-            DO  k = nzb_s_inner(j,i) + 1, nzt
-               kc     = kco(k+1)
-               glsf   = ( dx * dy * dzu(k) )**p13
-               glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
-               height = zu(k) - zu(nzb_s_inner(j,i))
-               fw     = EXP( -cfw * height / glsf )
-               tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) * ( glsf / glsc )**p23 )
-            ENDDO
-            tkefactor_l(nzb_s_inner(j,i),j) = c_tkef * fw0
-         ENDDO
-      ENDIF
-
-      IF ( nest_bound_r )  THEN
-         ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )    
-         tkefactor_r = 0.0_wp
-         i = nxr + 1
-         DO  j = nysg, nyng
-            DO  k = nzb_s_inner(j,i) + 1, nzt
-               kc     = kco(k+1)
-               glsf   = ( dx * dy * dzu(k) )**p13
-               glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-               height = zu(k) - zu(nzb_s_inner(j,i))
-               fw     = EXP( -cfw * height / glsf )
-               tkefactor_r(k,j) = c_tkef * (fw0 * fw + ( 1.0_wp - fw ) * ( glsf / glsc )**p23 )
-            ENDDO
-            tkefactor_r(nzb_s_inner(j,i),j) = c_tkef * fw0
-         ENDDO
-      ENDIF
+       IF ( nest_bound_l )  THEN
+          ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
+          tkefactor_l = 0.0_wp
+          i = nxl - 1
+          DO  j = nysg, nyng
+             DO  k = nzb_s_inner(j,i) + 1, nzt
+                kc     = kco(k+1)
+                glsf   = ( dx * dy * dzu(k) )**p13
+                glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
+                height = zu(k) - zu(nzb_s_inner(j,i))
+                fw     = EXP( -cfw * height / glsf )
+                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                                              ( glsf / glsc )**p23 )
+             ENDDO
+             tkefactor_l(nzb_s_inner(j,i),j) = c_tkef * fw0
+          ENDDO
+       ENDIF
+
+       IF ( nest_bound_r )  THEN
+          ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
+          tkefactor_r = 0.0_wp
+          i = nxr + 1
+          DO  j = nysg, nyng
+             DO  k = nzb_s_inner(j,i) + 1, nzt
+                kc     = kco(k+1)
+                glsf   = ( dx * dy * dzu(k) )**p13
+                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
+                height = zu(k) - zu(nzb_s_inner(j,i))
+                fw     = EXP( -cfw * height / glsf )
+                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                                              ( glsf / glsc )**p23 )
+             ENDDO
+             tkefactor_r(nzb_s_inner(j,i),j) = c_tkef * fw0
+          ENDDO
+       ENDIF
 
       IF ( nest_bound_s )  THEN
-         ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
-         tkefactor_s = 0.0_wp
-         j = nys - 1
-         DO  i = nxlg, nxrg
-            DO  k = nzb_s_inner(j,i) + 1, nzt
-               kc     = kco(k+1)
-               glsf   = ( dx * dy * dzu(k) )**p13
-               glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
-               height = zu(k) - zu(nzb_s_inner(j,i))
-               fw     = EXP( -cfw*height / glsf )
-               tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) * ( glsf / glsc )**p23 )
-            ENDDO
-            tkefactor_s(nzb_s_inner(j,i),i) = c_tkef * fw0
-         ENDDO
-      ENDIF
-
-      IF ( nest_bound_n )  THEN
-         ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
-         tkefactor_n = 0.0_wp    
-         j = nyn + 1
-         DO  i = nxlg, nxrg
-            DO  k = nzb_s_inner(j,i)+1, nzt
-               kc     = kco(k+1)
-               glsf   = ( dx * dy * dzu(k) )**p13
-               glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-               height = zu(k) - zu(nzb_s_inner(j,i))
-               fw     = EXP( -cfw * height / glsf )
-               tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) * ( glsf / glsc )**p23 )
-            ENDDO
-            tkefactor_n(nzb_s_inner(j,i),i) = c_tkef * fw0
-         ENDDO
-      ENDIF
-
-      ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
-      k = nzt
-      DO  i = nxlg, nxrg
-         DO  j = nysg, nyng
-            kc     = kco(k+1)
-            glsf   = ( dx * dy * dzu(k) )**p13
-            glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-            height = zu(k) - zu(nzb_s_inner(j,i))
-            fw     = EXP( -cfw * height / glsf )
-            tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) * ( glsf / glsc )**p23 )
-         ENDDO
-      ENDDO
+          ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
+          tkefactor_s = 0.0_wp
+          j = nys - 1
+          DO  i = nxlg, nxrg
+             DO  k = nzb_s_inner(j,i) + 1, nzt
+                kc     = kco(k+1)
+                glsf   = ( dx * dy * dzu(k) )**p13
+                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
+                height = zu(k) - zu(nzb_s_inner(j,i))
+                fw     = EXP( -cfw*height / glsf )
+                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                                              ( glsf / glsc )**p23 )
+             ENDDO
+             tkefactor_s(nzb_s_inner(j,i),i) = c_tkef * fw0
+          ENDDO
+       ENDIF
+
+       IF ( nest_bound_n )  THEN
+          ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
+          tkefactor_n = 0.0_wp
+          j = nyn + 1
+          DO  i = nxlg, nxrg
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                kc     = kco(k+1)
+                glsf   = ( dx * dy * dzu(k) )**p13
+                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
+                height = zu(k) - zu(nzb_s_inner(j,i))
+                fw     = EXP( -cfw * height / glsf )
+                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                                              ( glsf / glsc )**p23 )
+             ENDDO
+             tkefactor_n(nzb_s_inner(j,i),i) = c_tkef * fw0
+          ENDDO
+       ENDIF
+
+       ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
+       k = nzt
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             kc     = kco(k+1)
+             glsf   = ( dx * dy * dzu(k) )**p13
+             glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
+             height = zu(k) - zu(nzb_s_inner(j,i))
+             fw     = EXP( -cfw * height / glsf )
+             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
+                                           ( glsf / glsc )**p23 )
+          ENDDO
+       ENDDO
       
     END SUBROUTINE pmci_init_tkefactor
@@ -2366,7 +2462,5 @@
 
 !
-!-- List of array names, which can be coupled.
-!-- TO_DO: Antti: what is the meaning of the next line?
-!-- AH: Note that the k-range of the *c arrays is changed from 1:nz to 0:nz+1.
+!-- List of array names, which can be coupled
     IF ( TRIM( name ) == "u" )  THEN
        IF ( .NOT. ALLOCATED( uc ) )  ALLOCATE( uc(0:nzc+1, js:je, is:ie) )
@@ -2406,5 +2500,5 @@
        ELSE
 !
-!--       Avoid others to continue
+!--       Prevent others from continuing
           CALL MPI_BARRIER( comm2d, ierr )
        ENDIF
@@ -2650,4 +2744,102 @@
 
 
+ SUBROUTINE pmci_check_setting_mismatches
+!
+!-- Check for mismatches between settings of master and client variables
+!-- (e.g., all clients have to follow the end_time settings of the root model).
+!-- The root model overwrites variables in the other models, so these variables
+!-- only need to be set once in file PARIN.
+
+#if defined( __parallel )
+
+    USE control_parameters,                                                    &
+        ONLY:  dt_restart, end_time, message_string, restart_time, time_restart
+
+    IMPLICIT NONE
+
+    INTEGER ::  ierr
+
+    REAL(wp) ::  dt_restart_root
+    REAL(wp) ::  end_time_root
+    REAL(wp) ::  restart_time_root
+    REAL(wp) ::  time_restart_root
+
+!
+!-- Check the time to be simulated.
+!-- Here, and in the following, the root process communicates the respective
+!-- variable to all others, and its value will then be compared with the local
+!-- values.
+    IF ( pmc_is_rootmodel() )  end_time_root = end_time
+    CALL MPI_BCAST( end_time_root, 1, MPI_REAL, 0, comm_world_nesting, ierr )
+
+    IF ( .NOT. pmc_is_rootmodel() )  THEN
+       IF ( end_time /= end_time_root )  THEN
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'client settings &   end_time(root) = ', end_time_root,         &
+               ' &   end_time(client) = ', end_time, ' & client value is set', &
+               ' to root value'
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+                        0 )
+          end_time = end_time_root
+       ENDIF
+    ENDIF
+
+!
+!-- Same for restart time
+    IF ( pmc_is_rootmodel() )  restart_time_root = restart_time
+    CALL MPI_BCAST( restart_time_root, 1, MPI_REAL, 0, comm_world_nesting, ierr )
+
+    IF ( .NOT. pmc_is_rootmodel() )  THEN
+       IF ( restart_time /= restart_time_root )  THEN
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'client settings &   restart_time(root) = ', restart_time_root, &
+               ' &   restart_time(client) = ', restart_time, ' & client ',     &
+               'value is set to root value'
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+                        0 )
+          restart_time = restart_time_root
+       ENDIF
+    ENDIF
+
+!
+!-- Same for dt_restart
+    IF ( pmc_is_rootmodel() )  dt_restart_root = dt_restart
+    CALL MPI_BCAST( dt_restart_root, 1, MPI_REAL, 0, comm_world_nesting, ierr )
+
+    IF ( .NOT. pmc_is_rootmodel() )  THEN
+       IF ( dt_restart /= dt_restart_root )  THEN
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'client settings &   dt_restart(root) = ', dt_restart_root,     &
+               ' &   dt_restart(client) = ', dt_restart, ' & client ',         &
+               'value is set to root value'
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+                        0 )
+          dt_restart = dt_restart_root
+       ENDIF
+    ENDIF
+
+!
+!-- Same for time_restart
+    IF ( pmc_is_rootmodel() )  time_restart_root = time_restart
+    CALL MPI_BCAST( time_restart_root, 1, MPI_REAL, 0, comm_world_nesting, ierr )
+
+    IF ( .NOT. pmc_is_rootmodel() )  THEN
+       IF ( time_restart /= time_restart_root )  THEN
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'client settings &   time_restart(root) = ', time_restart_root, &
+               ' &   time_restart(client) = ', time_restart, ' & client ',     &
+               'value is set to root value'
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
+                        0 )
+          time_restart = time_restart_root
+       ENDIF
+    ENDIF
+
+#endif
+
+ END SUBROUTINE pmci_check_setting_mismatches
+
+
+
  SUBROUTINE pmci_ensure_nest_mass_conservation
 
@@ -2787,4 +2979,7 @@
     REAL(wp), DIMENSION(1) ::  dtl         !:
 
+
+    CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
+
 !
 !-- First find the smallest native time step of all the clients of the current
@@ -2813,4 +3008,6 @@
     ENDDO
 
+    CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
+
 #endif
  END SUBROUTINE pmci_server_synchronize
@@ -2836,4 +3033,7 @@
     dtl(1) = dt_3d
     IF ( cpl_id > 1 )  THEN
+
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'start' )
+
        IF ( myid==0 )  THEN
           CALL pmc_send_to_server( dtl, SIZE( dtl ), 0, 101, ierr )
@@ -2845,4 +3045,7 @@
 !--    Broadcast the unified time step to all server processes
        CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
+
+       CALL cpu_log( log_point_s(70), 'pmc sync', 'stop' )
+
     ENDIF
 
@@ -2853,4 +3056,7 @@
 
  SUBROUTINE pmci_set_swaplevel( swaplevel )
+!
+!-- After each Runge-Kutta sub-timestep, alternately set buffer one or buffer
+!-- two active
 
     IMPLICIT NONE
@@ -2862,6 +3068,4 @@
     INTEGER(iwp)            ::  m          !:
 
-!
-!-- After each timestep, alternately set buffer one or buffer two active
     DO  m = 1, SIZE( pmc_server_for_client )-1
        client_id = pmc_server_for_client(m)
@@ -2870,4 +3074,56 @@
 
  END SUBROUTINE pmci_set_swaplevel
+
+
+
+ SUBROUTINE pmci_datatrans( local_nesting_mode )
+!
+!-- Althoug nesting_mode is a variable of this model, pass it as an argument to
+!-- allow for example to force one-way initialization phase
+
+    IMPLICIT NONE
+
+    INTEGER(iwp)           ::  ierr   !:
+    INTEGER(iwp)           ::  istat  !:
+
+    CHARACTER(LEN=*),INTENT(IN) ::  local_nesting_mode
+
+    IF ( local_nesting_mode == 'one-way' )  THEN
+
+       CALL pmci_client_datatrans( server_to_client )
+       CALL pmci_server_datatrans( server_to_client )
+
+    ELSE
+
+       IF( nesting_datatransfer_mode == 'cascade' )  THEN
+
+          CALL pmci_client_datatrans( server_to_client )
+          CALL pmci_server_datatrans( server_to_client )
+
+          CALL pmci_server_datatrans( client_to_server )
+          CALL pmci_client_datatrans( client_to_server )
+
+       ELSEIF( nesting_datatransfer_mode == 'overlap')  THEN
+
+          CALL pmci_server_datatrans( server_to_client )
+          CALL pmci_client_datatrans( server_to_client )
+
+          CALL pmci_client_datatrans( client_to_server )
+          CALL pmci_server_datatrans( client_to_server )
+
+       ELSEIF( TRIM( nesting_datatransfer_mode ) == 'mixed' )  THEN
+
+          CALL pmci_server_datatrans( server_to_client )
+          CALL pmci_client_datatrans( server_to_client )
+
+          CALL pmci_server_datatrans( client_to_server )
+          CALL pmci_client_datatrans( client_to_server )
+
+       ENDIF
+
+    ENDIF
+
+ END SUBROUTINE pmci_datatrans
+
 
 
